/*
**************************************************************************************
************ Entete appel JSXGraph + Progiciels ************
<link rel="stylesheet" type="text/css" href="http://jsxgraph.uni-bayreuth.de/distrib/jsxgraph.css" />
<script type="text/javascript" src="http://jsxgraph.uni-bayreuth.de/distrib/jsxgraphcore.js""></script>
<script type="text/javascript" src="Progiciels.js"></script>
**************************************************************************************
************ Insertion de code Javascript pour declarer la zone graphique ************
<div id="zoneGraphique" class="jxgbox" style="width:600px; height:600px;"></div>
<script language="JavaScript">
initZoneGraphique("zoneGraphique",-100,100,-100,100);
initialisation();
</script>
**************************************************************************************
*/

var progiciels_zoneGraphique;
var progiciels_tortue;
var progiciels_remplissageEnCours = false;
var progiciels_courbeARemplir = null;
var progiciels_courbesRemplies =[];
var progiciels_couleurRemplissage = '#ffffff';
JXG.Turtle.prototype.setPos = function(x,y) {
    if (JXG.isArray(x)) { this.pos = x; } else { this.pos = [x,y]; }
    if (!this.turtleIsHidden) {
        this.turtle.setPositionDirectly(JXG.COORDS_BY_USER,x,y);
        this.turtle2.setPositionDirectly(JXG.COORDS_BY_USER,x,y+this.arrowLen);
        var t = this.board.createElement('transform', [(this.dir - 90)*Math.PI/180.0,this.turtle], {type:'rotate'});
        t.applyOnce(this.turtle2);}
    this.curve = this.board.createElement('curve',[[this.pos[0]],[this.pos[1]]],this.attributes);
    this.objects.push(this.curve);
    this.board.update();
    return this;};
debutRemplir = function(){ progiciels_remplissageEnCours = true;}
finRemplir = function(){
	if(!progiciels_courbeARemplir){return;}
	progiciels_courbeARemplir.dataX.push(progiciels_courbeARemplir.dataX[0]); progiciels_courbeARemplir.dataY.push(progiciels_courbeARemplir.dataY[0]);
	progiciels_courbeARemplir.setProperty({fillColor: progiciels_couleurRemplissage});  progiciels_remplissageEnCours = false;
	progiciels_courbesRemplies.push(progiciels_courbeARemplir); progiciels_courbeARemplir = null;}
initCourbeRemplis = function(){
	if(progiciels_courbeARemplir){return;}
	progiciels_courbeARemplir = progiciels_zoneGraphique.createElement('curve', [[progiciels_tortue.X()],[progiciels_tortue.Y()]], {});
	progiciels_courbeARemplir.dataX = [progiciels_tortue.X()]; progiciels_courbeARemplir.dataY =[progiciels_tortue.Y()];}
progiciels_detruireCourbesRemplies = function(){
	var n = progiciels_courbesRemplies.length;
	for (var i = n-1; i >= 0; i--){ progiciels_zoneGraphique.removeObject( progiciels_courbesRemplies[i].id);}
	progiciels_courbesRemplies = [];}
function couleurRemplissage(r,v,b) {progiciels_couleurRemplissage= couleur(r,v,b);};	
av = avance = function(d){
	if (progiciels_remplissageEnCours){initCourbeRemplis();};
	progiciels_tortue.forward(d); 
	if (progiciels_courbeARemplir){progiciels_courbeARemplir.dataX.push(progiciels_tortue.X()); progiciels_courbeARemplir.dataY.push(progiciels_tortue.Y());}};	
fPos = fixePosition = function(x, y){
	if (progiciels_remplissageEnCours){initCourbeRemplis();};
	if (crayonTrace()){ progiciels_tortue.moveTo([x, y]);} else { progiciels_tortue.setPos(x, y);}
	if (progiciels_remplissageEnCours){progiciels_courbeARemplir.dataX.push(progiciels_tortue.X()); progiciels_courbeARemplir.dataY.push(progiciels_tortue.Y());}};
function couleur(r,v,b) { var c; chaine="#"; 
       c=r.toString(16); if (c.length<2) {c="0"+c;}; chaine=chaine+c;
       c=v.toString(16); if (c.length<2) {c="0"+c;}; chaine=chaine+c;
       c=b.toString(16); if (c.length<2) {c="0"+c;}; chaine=chaine+c; return chaine;};
function couleurCrayon(r,v,b) {progiciels_tortue.setPenColor(couleur(r,v,b));};
function segment(x1,y1,x2,y2) { progiciels_tortue.setPos(x1,y1); fPos(x2,y2);};
function polygoneRegulier(n,cx,cy,r,ai) {
   for(var i=0;i<n;i=i+1) {
     segment(cx+r*cosD(ai+i*360/n),cy+r*sinD(ai+i*360/n),cx+r*cosD(ai+(i+1)*360/n),cy+r*sinD(ai+(i+1)*360/n));}};
function cercle(x,y,r) {polygoneRegulier(72,x,y,r,0)};
function disque(x,y,r) {debutRemplir(); cercle(x,y,r); finRemplir();};

PI = Math.PI;
saut_ligne = "\n";
racine = Math.sqrt;
puissance = Math.pow;
sin = Math.sin;
cos = Math.cos;
tan = Math.tan;
arccos =acos = Math.acos;
arcsin = asin = Math.asin;
arctan = atan = Math.atan;
exp = Math.exp;
log = Math.log;
abs = Math.abs;
alea = random = Math.random;
plafond = ceil = Math.ceil;
plancher = floor = Math.floor;
alea = Math.random;
cInt = cEnt = parseInt;
cDbl = cDec = parseFloat;
cStr = cChaine = function(x) {return x.toString();};
sinD = function(x) {return sin(x*PI/180); };
cosD = function(x) {return cos(x*PI/180); };
tanD = function(x) {return tan(x*PI/180); };
round = arrondir = function(x) {return plancher(x+0.5); };
hasard = function(a,b) {return plancher(a+(b-a+1)*alea())};

tortueCourante = function(t){ progiciels_tortue = t; };
dr = droite = function(angle){ progiciels_tortue.right(angle); };
crayonTrace = function(){ return progiciels_tortue.isPenDown; };
posX = function(){ return progiciels_tortue.X(); };
posY = function(){ return progiciels_tortue.Y(); };
cap = function(){ return progiciels_tortue.dir; };
fCap = fixeCap = function(angle){ progiciels_tortue.right(angle - cap()); };
capVers = function(x, y){ progiciels_tortue.lookTo([x, y]); };
lc = leveCrayon = function(){ progiciels_tortue.penUp(); };
bc = baisseCrayon = function(){ progiciels_tortue.penDown(); };
ve = videEcran = function(){ progiciels_detruireCourbesRemplies(); progiciels_tortue.clearScreen(); cacheTortue();};
tc = tailleCrayon = function(n){ progiciels_tortue.setPenSize(n);};
mt = montreTortue = function(){ progiciels_tortue.showTurtle(); };
ct = cacheTortue = function(){ progiciels_tortue.hideTurtle(); };


function initZoneGraphique(nomZone,xmin,xmax,ymin,ymax) {
	progiciels_zoneGraphique = JXG.JSXGraph.initBoard(nomZone, {boundingbox: [xmin,ymax,xmax,ymin], keepaspectratio:false, axis:false });
	progiciels_tortue = progiciels_zoneGraphique.createElement('turtle',[],{});
	couleurCrayon(0,0,0); cacheTortue(); }
function mettreAjour(vrai) {if (vrai) {progiciels_zoneGraphique.unsuspendUpdate();} else {progiciels_zoneGraphique.suspendUpdate();}}
cells = cellule = function(id) {return document.getElementById(id);};  // Utiliser "variable=cellule(id).value" et "cellule(id).value=expression"
	
// ****************************************
// * Definissez vos procedures ci-dessous *
// ****************************************

function initialisation() {
	auSignal();
}

function placerTortue(h,c){
	lc(); av(-h);dr(-90);av(-c/2);bc();
}

function polyReg(n,c){
	couleurCrayon(0,0,255);
	couleurRemplissage(200,200,255);
	debutRemplir();
	for(k=1;k<=n;k=k+1){
		av(c);dr(360/n);
	}
	finRemplir();
}

function auSignal() {
	n = cells("nbCotes").value;
	nb = cells("nbPoly").value;
	r = 100;
	h = r*cosD(180/n);
	c = 2*r*sinD(180/n);
	ve();
	placerTortue(h,c);
	for(m=1;m<=nb;m=m+1) {
		polyReg(n,c);
		av(c/2); dr(180/n); 
		r=r*cosD(180/n);
		c = 2*r*sinD(180/n);
	}
}

